/**
* @class Template
*/
var Template = function(){this.init.apply(this, arguments);};
exports.Template = Template;

Template.prototype.init = function(_template) {

	this.template = _template;
	this.nodes = [];
};

Template.prototype.render = function(_data) {

	var data = _data || {};

	if(!data.constructor || data.constructor != Array) { 

		data = [data];
	}

	with(this) {

		for (var i=0; i < data.length; i++) {

			eval("(" + this.template.toString() + ")(data[i])");
		};
	}

	var tops  = Template.getTopNodes(this.nodes);

	var output = "";

	tops.each(function(_node){

		output += _node.render();
	});

	return output;
};

//---------------------
// Add Class Fields/Methods

Template.TAGS_SET = false;

Template.TAGS = [];
Template.setTags = function(_tags) {

	Template.TAGS = _tags;
};
Template.HTML_TAGS = [
	"html", "head", "body", "script", "meta", "title", "link",
	"div", "p", "span", "a", "img", "br", "hr",
	"table", "tr", "th", "td", "thead", "tbody",
	"ul", "ol", "li", 
	"dl", "dt", "dd",
	"h1", "h2", "h3", "h4", "h5", "h6", "h7",
	"form", "input", "label",
	"iframe", "select", "optgroup", "option", "textarea"
];

Template.getTopNodes = function(_nodes) {

	var tops = [];

	_nodes.each(function(_node){

		if (!_node.parent) tops.add(_node);
	});

	return tops;
};

Template.initTemplate = function() {

	if(Template.TAGS_SET) { return; }

	Template.TAGS_SET = true;

	var tags = Template.TAGS;

	tags.each(function(_tag){

		var fn = function(_tag) {

			return function(_attrs) {

				var node = new Node(_tag);

				var firstArgIsAttributes = typeof(_attrs) == "object" && _attrs.constructor != Node && _attrs.constructor != TextNode;

				if (firstArgIsAttributes) node.setAttributes(_attrs);

				var startIndex = firstArgIsAttributes ? 1 : 0;

				for (var i=startIndex; i < arguments.length; i++) {

					var arg = arguments[i];

					if (typeof(arg) == "string" || !arg) {

						arg = new TextNode(arg || "");
					}

					if (arg.constructor == Node || arg.constructor == TextNode) {

						arg.parent = node;
					}

					node.addChild(arg);
				};

				this.nodes.add(node);

				return node;
			};
		};

		Template.prototype[_tag] = fn(_tag);
	});
};
