require("bn-lang");

var Node = require("bn-template").Node;
var Template = require("bn-template").Template;
var Templates = require("bn-template").Templates;

// set to html templating

Node.setSelfClosingTags(Node.HTML_SELF_CLOSING_TAGS);
Template.setTags(Template.HTML_TAGS);

// need to be global

TEMPLATES = new Templates();

TEMPLATES.register('grid_tpl', function(_columns) {
	div({style:'width:auto;margin:auto;'},
		div({style:'padding:100px 200px 0px;'},
			div({style:'width:auto; margin:0 0 1em;'},
				div({id:'dashboard'},
					TEMPLATES.render('column_tpl', _columns)
				)
			)
		)
	)
});

TEMPLATES.register('column_tpl', function(_column) {
	div({cls:'g_column',style:'float:left;'},
		TEMPLATES.render('box_tpl', _column.boxes)
	)
});

TEMPLATES.register('box_tpl', function(_box) {
	div({cls:'g_box',style:'margin:2px;'},
		div({cls:'g_root',style:'margin-bottom:10px;'},
			div({cls:'g_handle', style:'background-color:yellow;width:200px;height:25px;'},
				TEMPLATES.render('handle_tpl', _box.handle)
			),
			div({cls:'g_content', style:'background-color:'+_box.color+';width:200px;height:75px;'},
				TEMPLATES.render('content_tpl', _box.content)
			)
		)
	)
});

TEMPLATES.register('handle_tpl', function(_handle) {
  div({style:'text-align:center;'}, _handle.title);
});

TEMPLATES.register('content_tpl', function(_content) {
  div({style:'text-align:center;width:100%;height:100%;padding-top:20px;'}, _content.text);
});

exports.out = TEMPLATES.render("grid_tpl", require("./data").columns);